using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;

namespace MARSApp
{
    class Program
    {
        static void Main(string[] args)
        {
            //UseOutput();
            UseTrigger();
        }

        static void UseOutput()
        {
            using (SqlConnection conn = new SqlConnection("server=.;integrated security=sspi;database=credit;multipleactiveresultsets=true"))
            using (SqlCommand cmd1 = new SqlCommand())
            using (SqlCommand cmd2 = new SqlCommand())
            {
                cmd1.CommandText = "update charge set charge_code = 'A' output inserted.member_no, inserted.charge_no where charge_no < 500000";
                cmd1.Connection = conn;

                cmd2.CommandText = "select * from member where member_no = @id";
                cmd2.Connection = conn;
                cmd2.Parameters.Add("@id", System.Data.SqlDbType.Int);

                conn.Open();
                SqlTransaction tx = conn.BeginTransaction();
                cmd1.Transaction = cmd2.Transaction = tx;
                SqlDataReader rdr1 = cmd1.ExecuteReader();
                while (rdr1.Read())
                {
                    Console.WriteLine(rdr1[0]);
                    cmd2.Parameters[0].Value = (int)rdr1[0];
                    SqlDataReader rdr2 = cmd2.ExecuteReader();
                    while (rdr2.Read())
                        Console.WriteLine(rdr2[0]);
                    rdr2.Close();
                }
                rdr1.Close();
                tx.Commit();
            }
        }


        /* We first need this trigger on jobs
            drop trigger jobtrig
            go
            create trigger jobtrig
             on jobs for update
            as
            begin
              -- needs to be a large resultset
              select e.job_id, e.*, j.* from employee e, jobs j, northwind.dbo.orders o
            end
        */

        static void UseTrigger()
        {
            using (SqlConnection conn = new SqlConnection("server=.;integrated security=sspi;database=pubs;multipleactiveresultsets=true"))
            using (SqlCommand cmd1 = new SqlCommand())
            using (SqlCommand cmd2 = new SqlCommand())
            {
                cmd1.CommandText = "update jobs set job_desc = 'foo' ";
                cmd1.Connection = conn;

                cmd2.CommandText = "select * from authors";
                cmd2.Connection = conn;
                //cmd2.Parameters.Add("@jobid", System.Data.SqlDbType.SmallInt);

                conn.Open();
                SqlTransaction tx = conn.BeginTransaction();
                cmd1.Transaction = cmd2.Transaction = tx;
                SqlDataReader rdr1 = cmd1.ExecuteReader();
                while (rdr1.Read())
                {
                    Console.WriteLine(rdr1[0]);
                    //cmd2.Parameters[0].Value = (short)rdr1[0];
                    SqlDataReader rdr2 = cmd2.ExecuteReader();
                    while (rdr2.Read())
                        Console.WriteLine(rdr2[0]);
                    rdr2.Close();
                }
                rdr1.Close();
                tx.Commit();
            }
        }

    }
}
