using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;

namespace MARSOptions
{
    class Program
    {
        static void Main(string[] args)
        {
            using (SqlConnection conn = new SqlConnection("server=.;integrated security=sspi;database=pubs;multipleactiveresultsets=true"))
            using (SqlCommand cmd1 = new SqlCommand())
            using (SqlCommand cmd2 = new SqlCommand())
            {
                cmd1.Connection = cmd2.Connection = conn;
                cmd1.CommandText = "set lock_timeout -1;insert jobs values('row1',10,10);dbcc useroptions";
                cmd2.CommandText = "set lock_timeout 10;insert jobs values('row2',10,10);dbcc useroptions";

                conn.Open();

                // The statement that finishes last gets their options restored
                // Because the resultset is so small,
                // the statements actually finish here.
                // Switching the order of execution here, switches which timeout is set 
                // for the next execution.
                SqlDataReader rdr1 = cmd1.ExecuteReader();
                SqlDataReader rdr2 = cmd2.ExecuteReader();
               
                bool r1, r2;
                do
                {
                    r1 = rdr1.Read();
                    if (r1)
                        Console.WriteLine("Reader 1: Option={0},Value={1}", rdr1[0], rdr1[1]);
                    r2 = rdr2.Read();
                    if (r2)
                        Console.WriteLine("Reader 2: Option={0},Value={1}", rdr2[0], rdr2[1]);
                }
                while (r1 || r2);

                rdr1.Close();
                rdr2.Close();
                Console.WriteLine("After closing sessions");

                cmd1.CommandText = "DBCC USEROPTIONS";
                rdr1 = cmd1.ExecuteReader();

                while (rdr1.Read())
                    Console.WriteLine("Reader 1: Option={0},Value={1}", rdr1[0], rdr1[1]);
                rdr1.Close();
            }
        }
    }
}
