using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using System.Transactions;


public partial class StoredProcedures
{
    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void MyProc()
    {
        using (TransactionScope ts = new TransactionScope())
        using (SqlConnection conn = new SqlConnection("context connection=true"))
        using (SqlCommand cmd  = new SqlCommand("insert jobs values('test',10,10)", conn))
        {
            conn.Open();
            cmd.ExecuteNonQuery();
            ts.Complete();
        }
    }

    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void MyProc2()
    {
        SqlTransaction tx = null;
        
        using (SqlConnection conn = new SqlConnection("context connection=true"))
        using (SqlCommand cmd  = new SqlCommand("insert jobs values('test',10,10)", conn))
        {
            conn.Open();
            tx = conn.BeginTransaction();
            cmd.Transaction = tx;
            cmd.ExecuteNonQuery();
            tx.Commit();
        }
    }

    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void MyProc3()
    {
        bool hasTx = false;
        if (Transaction.Current != null)
            hasTx = true;
        SqlTransaction tx = null;
        
        using (SqlConnection conn = new SqlConnection("context connection=true"))
        using (SqlCommand cmd  = new SqlCommand("MyProc2", conn))
        {
            cmd.CommandType = CommandType.StoredProcedure;

            conn.Open();
            if (!hasTx)
            {
                tx = conn.BeginTransaction();
                cmd.Transaction = tx;
            }
            cmd.ExecuteNonQuery();
            if (!hasTx)
                tx.Commit();
        }
    }
};
